import java.util.Scanner;
import java.util.InputMismatchException;

class Array {
    private double[] arr;
    Array() {
        takeInput();
    }
    void takeInput() {
        Scanner sc = new Scanner(System.in);
        System.out.print("Enter the length: ");
        int size = sc.nextInt();
        arr = new double[size];
        System.out.print("Enter the array elements: ");
        for (int i = 0; i < size; i++)
            arr[i] = sc.nextDouble();
    }
    void display() {
        System.out.print("The array elements are:");
        for (int i = 0; i < arr.length; i++)
            System.out.print(" " + arr[i]);
        System.out.println();
    }
    double get(int i) 
            throws IndexOutOfBoundsException {
        return arr[i];
    }
    void set(int i, double val) 
            throws IndexOutOfBoundsException {
        arr[i] = val;
    }
    int size() { return arr.length; }
}

class ArrayOperations {
    static int linearSearch(Array arr, double item) {
        int size = arr.size();
        for (int i = 0; i < size; i++) {
            if (arr.get(i) == item) 
                return i;
        }
        return -1;
    }
    static void bubbleSort(Array arr) {
        int size = arr.size();
        for (int i = size - 1; i > 1; i--) {
            for (int j = 0; j < i; j++) {
                double x = arr.get(j), xp = arr.get(j + 1);
                if (x > xp) {
                    arr.set(j, xp);
                    arr.set(j + 1, x);
                }
            }
        }
    }
}

class ArrayCLI {
    static void menu() {
        System.out.println(
            "Menu:\n" +
            " 1. Re-enter array\n" +
            " 2. Display array elements\n" +
            " 3. Perform linear search\n" +
            " 4. Perform bubble sort\n" +
            " 5. Exit\n");
    }
    static void performLinearSearch(Scanner sc, Array arr) {
        arr.display();
        System.out.print("Enter the item to find in the array: ");
        double item = sc.nextDouble();
        int index = ArrayOperations.linearSearch(arr, item);
        if (index == -1) {
            System.out.println("The item " + item + " was not found in the array.");
        } else {
            System.out.println("The item " + item + " was found in the array at position " + (index + 1) + ".");
        }
    }
    static void performBubbleSort(Array arr) {
        System.out.print("Before sorting: ");
        arr.display();
        ArrayOperations.bubbleSort(arr);
        System.out.print("After sorting: ");
        arr.display();
    }
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println("Menu-driven program of array operations\n");
        System.out.println("Enter the array:");
        Array arr = new Array();
        while (true) {
            menu();
            System.out.print("Enter your choice: ");
            int choice = sc.nextInt();
            switch (choice) {
            case 1:
                arr.takeInput();
                arr.display();
                break;
            case 2:
                arr.display();
                break;
            case 3:
                performLinearSearch(sc, arr);
                break;
            case 4:
                performBubbleSort(arr);
                break;
            case 5:
                System.out.println("Bye.");
                return;
            }
        }
    }
}

