interface CircularBase {
  public double baseArea();
  public void display();
}

abstract class _3DShape {
  protected double height;
  public abstract double volume();
}

class Cone extends _3DShape implements CircularBase {
  private double baseRadius;
  Cone(double br, double h) {
    baseRadius = r;
    height = h;
  }
  public double baseArea() { return Math.PI * baseRadius * baseRadius; }
  public void display() {
    System.out.println("Circular shape");
    System.out.println("  Radius: " + radius + " units.");
    System.out.println("  Area: " + area() + " square units.\n");
  }
}

class Cyllinder extends _3DShape implements CircularBase {
  private double radius;
  Cyllinder(double r, double h) {
    radius = r;
    height = h;
  }
  public double baseArea() { return 4.0 * Math.PI * radius * radius; }
  public void display() {
    System.out.println("Spherical shape");
    System.out.println("  Radius: " + radius + " units.");
    System.out.println("  Surface area: " + area() + " square units.\n");
  }
}

class Circular3DExample {
  public static void main(String args[]) {
    if (args.length != 2) {
      System.err.println("Usage: Circular3DExample <radius> <height>");
      System.exit(1);
    }
    try {
      double radius = Double.parseDouble(args[0]);
      double height = Double.parseDouble(args[1]);
      Shape sh;
      sh = new Circle(radius);
      sh.display();
      sh = new Sphere(radius);
      sh.display();
    } catch (NumberFormatException nfe) {
      System.err.println("Invalid radius");
    }
  }
}
