interface Shape {
  public double area();
  public void display();
}

class Circle implements Shape {
  protected double radius;
  Circle(double r) { radius = r; }
  public double area() { return Math.PI * radius * radius; }
  public void display() {
    System.out.println("Circular shape");
    System.out.println("  Radius: " + radius + " units.");
    System.out.println("  Area: " + area() + " square units.\n");
  }
}

class Sphere extends Circle implements Shape {
  Sphere(double r) { super(r); }
  @Override
  public double area() { return 4.0 * Math.PI * radius * radius; }
  public void display() {
    System.out.println("Spherical shape");
    System.out.println("  Radius: " + radius + " units.");
    System.out.println("  Surface area: " + area() + " square units.\n");
  }
}

class ShapeExample {
  public static void main(String args[]) {
    if (args.length != 1) {
      System.err.println("Usage: ShapeExample <radius>");
      System.exit(1);
    }
    try {
      double radius = Double.parseDouble(args[0]);
      Shape sh;
      sh = new Circle(radius);
      sh.display();
      sh = new Sphere(radius);
      sh.display();
    } catch (NumberFormatException nfe) {
      System.err.println("Invalid radius");
    }
  }
}
