import java.util.Scanner;

class Complex {
	double real, imag;
	Complex(double r, double i) {
		real = r;
		imag = i;
	}
	double modulus() {
		return Math.sqrt(real * real + imag * imag);
	}
	// Finds the reciprocal. (i.e. 1/z for a complex number z.)
	Complex reciprocal() {
		var m = this.modulus();
		return new Complex(real / m, imag / m);
	}
	@Override
	public String toString() {
		return real + (imag > 0.0 ? " + " : " - ") + Math.abs(imag) + "i";
	}
}

class ComplexOperations {
	static Complex add(Complex a, Complex b) {
		return new Complex(a.real + b.real, a.imag + b.imag);
	}
	static Complex subtract(Complex a, Complex b) {
		return new Complex(a.real - b.real, a.imag - b.imag);
	}
	static Complex multiply(Complex a, Complex b) {
		return new Complex(a.real * b.real - a.imag * b.imag,
				   a.real * b.imag + a.imag * b.real);
	}
	static Complex divide(Complex a, Complex b) {
		return ComplexOperations.multiply(a, b.reciprocal());
	}
}

class ComplexCalculations {
	static Complex takeComplexInput() {
		var sc = new Scanner(System.in);
		System.out.print("Enter real part: ");
		var real = sc.nextDouble();
		System.out.print("Enter imaginary part: ");
		var imaginary = sc.nextDouble();
		return new Complex(real, imaginary);
	}
	public static void main(String args[]) {
		System.out.println("First complex number:-");
		var x = takeComplexInput(); 
		System.out.println("Modulus: " + x.modulus());
		System.out.println("Second complex number:-");
		var y = takeComplexInput();
		System.out.println("Modulus: " + y.modulus());
		System.out.println();
		System.out.println("(" + x + ") + (" + y + ") = " + ComplexOperations.add(x, y));
		System.out.println("(" + x + ") - (" + y + ") = " + ComplexOperations.subtract(x, y));
		System.out.println("(" + x + ") * (" + y + ") = " + ComplexOperations.multiply(x, y));
		System.out.println("(" + x + ") / (" + y + ") = " + ComplexOperations.divide(x, y));
	}
}
