import java.util.Scanner;

class Rect {
	double length, width;
	// Construct default rectangle which is an unit square.
	Rect() {
		length = width = 1.0;
	}
	// Construct a rectangle which is a square.
	Rect(double sideLength) {
		length = width = sideLength;
	}
	Rect(double len, double wid) {
		length = len;
		width = wid;
	}
	// Area of a rectangle.
	double area() {
		return length * width;
	}
	void display() {
		System.out.println("A rectangle with length of " + length + " units and width of " + width + " units.");
	}
}

class RectAreaCalc {
	public static void main(String args[]) {
		var sc = new Scanner(System.in);
		System.out.println("Choose the shape: ");
		System.out.println("1. Unit square\n2. Square\n3. Rectangle");
		System.out.print("Enter your choice: ");
		var choice = sc.nextInt();
		switch (choice) {
		case 1:
			var usq = new Rect();
			usq.display();
			System.out.println("Area of the unit square: " + usq.area() + " square units.");
			break;
		case 2:
			System.out.print("Enter side length: ");
			var sidelen = sc.nextInt();
			var sq = new Rect(sidelen);
			sq.display();
			System.out.println("Area of the square: " + sq.area() + " square units.");
			break;
		case 3:
			System.out.print("Enter length and width: ");
			var len = sc.nextInt();
			var wid = sc.nextInt();
			var rect = new Rect(len, wid);
			rect.display();
			System.out.println("Area of the rectangle: " + rect.area() + " square units.");
			break;
		default:
			System.out.println("Invalid choice");
			break;
		}
	}
}
