class Cylinder {
	double radius, height;
	Cylinder(double r, double h) {
		radius = r;
		height = h;
	}
	double volume() {
		return Math.PI * radius * radius * height;
	}
	double surfaceArea() {
		return 2 * Math.PI * radius * height * (radius + height);
	}
}

class CylinderCalculationsCLI {
	public static void main(String args[]) {
		if (args.length != 2) {
			System.err.println("Usage: CylinderCalculationsCLI radius height");
			System.exit(1);
		}
		try {
			var radius = Double.parseDouble(args[0]);
			var height = Double.parseDouble(args[1]);
			var cy = new Cylinder(radius, height);
			System.out.println("Given: ");
			n1.display();
			n2.display();
			var n3 = ArithmeticOperations.add(n1, n2);
			System.out.println("With the addition of the two numbers, we have:");
			n3.display();
		} catch (NumberFormatException nfe) {
			System.err.println("Invalid numbers");
		}
	}
}
