import java.util.Scanner;
import java.util.InputMismatchException;
import java.util.stream.LongStream;

class PrimeRange {
    static boolean isPrime(long n) {
	if (n < 2) {
	    return false;
	}
	long nn = (long) Math.sqrt(n);
	for (long i = 2; i <= nn; i++) {
	    if (n % i == 0) {
		return false;
	    }
	}
	return true;
    }
    public static void main(String args[]) {
        try {
            Scanner i = new Scanner(System.in);
            System.out.print("Enter the range: ");
            var lower = i.nextLong();
	    var upper = i.nextLong();
            System.out.print("Prime numbers in the range of " + lower + " to " + upper + " are:");
	    LongStream.range(lower, upper)
		.filter(PrimeRange::isPrime)
		.forEach(n -> System.out.print(" " + n));
	    System.out.println();
        } catch (InputMismatchException e) {
            System.err.println("Invalid input for range.");
        }
    }
}

