class Marks {
    int obtained, full;
    Marks(int obtained, int full) {
        this.obtained = obtained;
        this.full = full;
    }
    @Override
    public String toString() {
        return obtained + " out of " + full;
    }
    static Marks total(Marks... ms) {
        int totalObtained = 0, totalFull = 0;
        for (var m : ms) {
            totalObtained += m.obtained;
            totalFull += m.full;
        }
        return new Marks(totalObtained, totalFull);
    }
}

class Subject {
    String title;
    Marks internal, theory;
    Subject(String title, Marks internal, Marks theory) {
        this.title = title;
        this.internal = internal;
        this.theory = theory;
    }
    @Override
    public String toString() {
        return internal + " marks in " + title + " internal, " + theory + " marks in " + title + " theory";
    }
}

class Student {
    long rollNo;
    String name;
    String stream;
    String college;
    Subject[] subjects;
    Student(long rollNo, String name, String stream, String college, Subject subjects[]) {
        this.rollNo = rollNo;
        this.name = name;
        this.stream = stream;
        this.college = college;
        this.subjects = subjects;
    }
    void display() {
        System.out.println("A student named " + name + " studies in the " + stream + " stream in " + college + ".");
        
     }
}

class StudentsWithFixedSubjects {
    public static void main(String args[]) {
        var s1 = new Student(107, "Bernhardt Schulz", "Science", "Hochschule für Technik und Wirtschaft Berlin");
        var s2 = new Student(3582, "Lin Suheng", "Commerce", "Beijing College of Finance and Commerce");
        s1.display();
        s2.display();
    }
}

