import java.util.*;

class Subject {
    String title;
    int internal, theory;
    Subject(String title, int internal, int theory) {
        this.title = title;
        this.internal = internal;
        this.theory = theory;
    }
    static Subject input(Scanner sc) {
    	System.out.println("Enter details of subject:");
    	System.out.print("Enter title: ");
    	String title = sc.nextLine();
    	System.out.print("Enter internal marks: ");
    	int internal = sc.nextLong();
    	System.out.print("Enter theory marks: ");
    	int theory = sc.nextLine();
    	sc.skip("\n");
    	return new Subject(title, internal, theory);
    }
    void display() {
    	System.out.println("  Subject " + title + " marks obtained:");
	    System.out.println("    Internal: " + internal);
	    System.out.println("    Theory: " + theory);
	    System.out.println("    Total: "  + internal + theory);
    }
}

class Student {
    long roll;
    String name;
    String stream;
    String college;
    Subject[] subjects;
    Student(long roll, String name, String stream, String college,
            Subject[] subjects) {
        this.roll = roll;
        this.name = name;
        this.stream = stream;
        this.college = college;
        this.subjects = subjects;
    }
    static Student input(Scanner sc) {
    	System.out.println("Enter the details of the student:");
    	System.out.print("Enter Roll no.: ");
    	long roll = sc.nextLong();
    	sc.skip("\n");
    	System.out.print("Enter name: ");
    	String name = sc.nextLine();
    	System.out.print("Enter stream: ");
    	String stream = sc.nextLine();
    	System.out.print("Enter college: ");
    	String college = sc.nextLine();
    	Subject[] subjects = new Subject[6];
    	for (int i = 0; i < 6; i++) {
    	    System.out.print("For subject " + (i + 1) + ": ");
    	    subjects[i] = Subject.input(sc);
    	}
    	return new Student(roll, name, stream, college, subjects);
    }
    void display() {
    	System.out.println("Student details:");
	    System.out.println("  Roll No.: " + roll);
	    System.out.println("  Name: " + name);
	    System.out.println("  Stream: "  + stream);
	    System.out.println("  College: " + college);
    }
}

class StudentsWithSubjects {
    public static void main(String args[]) {
	    var sc = new Scanner(System.in);
    	Student s1, s2;
    	System.out.print("For student 1: ");
    	s1 = Student.input(sc);
    	System.out.print("\nFor student 2: ");
    	s2 = Student.input(sc);
    	System.out.println("\nFor student 1: ");
    	s1.display();
    	System.out.print("\nFor student 2: ");
    	s2.display();
    }
}

