import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;
import java.util.InputMismatchException;

class Number {
    double value;
    Number(double n) {
        value = n;
    }
    void display() {
        System.out.println("A number with value: " + value);
    }
}

class ArithmeticOperations {
    static Number add(Number a, Number b) {
        return new Number(a.value + b.value);
    }
}

class AddTwoNumbers {
    static void process(double a, double b) {
        var n1 = new Number(a);
        var n2 = new Number(b);
        System.out.println("Given: ");
        n1.display();
        n2.display();
        var n3 = ArithmeticOperations.add(n1, n2);
        System.out.println("With the addition of the two numbers, we have:");
        n3.display();
    }
}

class AddTwoNumbersCLI extends AddTwoNumbers {
    public static void main(String args[]) {
        if (args.length != 2) {
            System.err.println("Usage: AddTwoNumbersCLI first-number second-number");
            System.exit(1);
        }
        try {
            var v1 = Double.parseDouble(args[0]);
            var v2 = Double.parseDouble(args[1]);
            process(v1, v2);
        } catch (NumberFormatException e) {
            System.err.println("Invalid numbers");
        }
    }
}

class AddTwoNumbersScan extends AddTwoNumbers {
    public static void main(String args[]) {
        try {
            var sc = new Scanner(System.in);
            System.out.print("Enter first number: ");
            var v1 = sc.nextDouble();
            System.out.print("Enter second number: ");
            var v2 = sc.nextDouble();
            process(v1, v2);
        } catch (InputMismatchException e) {
            System.err.println("Invalid numbers");
        }
    }
}

class AddTwoNumbersBuf extends AddTwoNumbers {
    public static void main(String args[]) {
        try {
            var r = new BufferedReader(new InputStreamReader(System.in));
            System.out.print("Enter first number: ");
            var v1 = Double.parseDouble(r.readLine());
            System.out.print("Enter second number: ");
            var v2 = Double.parseDouble(r.readLine());
            process(v1, v2);
        } catch (NumberFormatException e) {
            System.err.println("Invalid numbers");
        } catch (IOException e) {
            System.err.println("I/O error occured while reading input.");
        }
    }
}

