import java.util.Scanner;
import java.util.InputMismatchException;

abstract class Shape {
	abstract double area();
	abstract void display();
}

class Rectangle extends Shape {
	double length, width;
	Rectangle(double len, double wid) {
		length = len;
		width = wid;
	}
	double area() {
		return length * width;
	}
	void display() {
		System.out.println("A rectangle with length " + length + " units and width " + width + " units has the area of " + area() + " square units.");
	}
}

class Square extends Shape {
	double sideLength;
	Rectangle(double slen) {
		sideLength = slen;
	}
	double area() {
		return sideLength * sideLength;
	}
	void display() {
		System.out.println("A square with side length " + length + " units has the area of " + area() + " square units.");
	}
}

class Triangle extends Shape {
	double a, b, c;
	Rectangle(double s1, double s2, double s3) {
		a = s1;
		b = s2;
		c = s3;
	}
	double perimeter() {
		return a + b + c;
	}
	double area() {
		var s = perimeter() / 2.0;
		return Math.sqrt(s * (s - a) * (s - b) * (s - c));
	}
	void display() {
		System.out.println("A triangle with side lengths " + a + " units, " + b + "units and " + c + " units has the area of " + area() + " square units.");
	}
}

class ManyShapes {
	public static void main(String args[]) {
		
	}
}
