#let page-margin = (left: 1in, right: 0.75in, top: 0.5in, bottom: 0.25in)
#let margin = (left: 0.75in, right: 0.75in, top: 2em, bottom: 2em)
#let page-frame-thickness = 1.5pt
#set page(
  margin: (..page-margin, bottom: margin.bottom + 2em),
  numbering: "1",
  background: align(top + start, pad(..margin, rect(width: 100%, height: 100%, stroke: page-frame-thickness + gray))),
  footer: locate(loc => align(center, move(dy: -margin.bottom + 1em, text(font: "Lato", counter(page).display(loc.page-numbering())))))
)
#show: block.with(breakable: true, width: 100%, inset: page-frame-thickness + 1em)

#set text(font: "Nunito Sans 10pt", size: 12pt, stretch: 75%)
#show raw: set text(font: "CommitMono")
#show raw.where(block: false): box.with(
  fill: luma(245),
  inset: (x: 3pt, y: 0pt),
  outset: (y: 3pt),
  radius: 2pt,
)
#show raw.where(block: true): block.with(
  fill: luma(245),
  inset: 10pt,
  radius: 4pt,
)
#show raw.where(block: true): it => align(center, it)
#set par(leading: 0.5em)
#let assignment(number) = {
  set text(1.5em)
  set align(center)
  [*Assignment #number *]
}

#assignment(1)

Write the SQL commands to following relations.
Specify required integrity constraints. Insert suitable tuples such that the given queries produce some results.

```
EMPLOYEE: (EMPNO, ENAME, JOB, HIREDATE, SALARY, COMMISSION, MGR, DEPTNO)
DEPARTMENT: (DNO, DNAME, LOC)
```

*Answer:* The SQL queries are listed below.

```sql
CREATE TABLE DEPARTMENT (DNO INT PRIMARY KEY, DNAME VARCHAR(50) NOT NULL, LOC VARCHAR(100) NOT NULL);

INSERT INTO DEPARTMENT (DNO, DNAME, LOC) VALUES (10, "Design", "Pune"), (20, "Maintainance", "Delhi"), (30, "Sales", "Bangalore"), (40, "Finance", "Bhubaneswar"), (50, "Marketing", "Kolkata");
```

Write the SQL commands to perform the following queries: 
+ Display each employee’s name, job, salary and department number. 
+ Display employee’s name who are earning more than Rs. 2000 label the column name “List of Employees”.
+ Display employees who are not clerk or salesman. Order the list by employee name. 
+ Display the employee names and salaries of those having salaries less than their commission. Label the employee name “Name” and salary column “Salary”. 
+ Display the employees hired in 1999.
+ Display the names and jobs of all employees in departments 10 and 20 in alphabetical order of name. 
+ List the name, job, salary for all employees who have a manager.
+ Display name, annual salary and commission of all salespeople whose monthly salary is greater than their commission. The output should be ordered by highest salary first. 
+ List the department number and number of employee in each department. 
+ List the average salary for all departments more than 3 people. 
+ List jobs of all the employee where maximum salary is greater than or equal to 5000. 
+ List the department number and total salary payable in each department. 
+ List the jobs and the number of employees in each job. The result should be in descending order of the number of employees. 
+ List the total salary, maximum and minimum salary of employees job wise. 
+ List the average salary from each job excluding managers.
+ List the total, maximum, minimum and the average salary of employee job wise for department number 20 only. 
+ List the total, maximum, minimum and the average salary of employee job wise for department number 20 and display only those having average salary > 10000. 
+ Find out the difference between highest and lowest salaries. 
+ In which year did most people joined the company? Display the year and number of employees. 
+ Find the recently hired employee in each department ordered by hire date.

