#let body-font-settings = (font: "Nunito Sans 10pt", size: 12pt, stretch: 75%)

#let page-margin = (left: 1in, right: 0.75in, top: 0.5in, bottom: 0.25in)
#let margin = (left: 0.75in, right: 0.75in, top: 2em, bottom: 2em)
#let page-frame-thickness = 1.5pt
#set page(
  margin: (..page-margin, bottom: margin.bottom + 2em),
  numbering: "1",
  background: align(top + start, pad(..margin, rect(width: 100%, height: 100%, stroke: page-frame-thickness + gray))),
  footer: locate(loc => align(center, move(dy: -margin.bottom + 1em, text(..body-font-settings, size: 9pt, counter(page).display(loc.page-numbering())))))
)
#show: block.with(breakable: true, width: 100%, inset: page-frame-thickness + 1em)

#set text(..body-font-settings)
#show raw: set text(font: "CommitMono")
#show raw.where(block: false): box.with(
  fill: luma(245),
  inset: (x: 3pt, y: 0pt),
  outset: (y: 3pt),
  radius: 2pt,
)
#show raw.where(block: true): block.with(
  fill: luma(245),
  inset: 10pt,
  radius: 4pt,
)
#show raw.where(block: true): it => align(center, it)
#set par(leading: 0.5em)
#let assignment(number) = {
  set text(1.5em)
  set align(center)
  [*Assignment #number *]
}

#assignment(1)

Write the SQL commands to following relations.
Specify required integrity constraints. Insert suitable tuples such that the given queries produce some results.

```
EMPLOYEE: (EMPNO, ENAME, JOB, HIREDATE, SALARY, COMMISSION, MGR, DEPTNO)
DEPARTMENT: (DNO, DNAME, LOC)
```

Write the SQL commands to perform the following queries: 
+ Display each employee’s name, job, salary and department number. 
+ Display employee’s name who are earning more than Rs. 2000 label the column name “List of Employees”.
+ Display employees who are not clerk or salesman. Order the list by employee name. 
+ Display the employee names and salaries of those having salaries less than their commission. Label the employee name “Name” and salary column “Salary”. 
+ Display the employees hired in 1999.
+ Display the names and jobs of all employees in departments 10 and 20 in alphabetical order of name. 
+ List the name, job, salary for all employees who have a manager.
+ Display name, annual salary and commission of all salespeople whose monthly salary is greater than their commission. The output should be ordered by highest salary first. 
+ List the department number and number of employee in each department. 
+ List the average salary for all departments more than 3 people. 
+ List jobs of all the employee where maximum salary is greater than or equal to 5000. 
+ List the department number and total salary payable in each department. 
+ List the jobs and the number of employees in each job. The result should be in descending order of the number of employees. 
+ List the total salary, maximum and minimum salary of employees job wise. 
+ List the average salary from each job excluding managers.
+ List the total, maximum, minimum and the average salary of employee job wise for department number 20 only. 
+ List the total, maximum, minimum and the average salary of employee job wise for department number 20 and display only those having average salary > 10000. 
+ Find out the difference between highest and lowest salaries. 
+ In which year did most people joined the company? Display the year and number of employees. 
+ Find the recently hired employee in each department ordered by hire date.

#colbreak()

#assignment(2)

Write the SQL comments to the following relations. 
Specify required integrity constraints. Insert suitable tuples such thatqueries produce some results.

```
BORROWER: (bid, bname) 
BOOK: (bookid, title, author, subject) 
BORROWS: (bookid, bid, date_of_issue, date_of_return) 
```

Write the SQL comments to perform the following queries: 

+ Give all the books on “Physics” and “Mathematics”. 
+ Find out all the title and author of all books issued by the borrower whose `bid='boo1'`.
+ Find out the names of the borrowers who have issued books written by “C J Date”. 
+ Find all the books written by “Mity Ghosh” on ‘Mathematics’.
+ Find the total number of books in the Library.
+ Find the names the borrowers who have borrowed one or more book on ‘DBMS’.
+ List the ID and name of the person who did not borrow any book.
+ Find the name of books which are not borrowed by any borrower.
+ Find the name of the borrower who has borrowed one or more books on ‘Operating System’.
+ Find borrower name containing the middle name “Chandra”.

#assignment(3)

Write the SQL comments to the following relations.
Specify required integrity constraints. Insert suitable tuples such that queries produce some results.

```
CUSTOMER: (cid, cname, city, phno)
ITEMS: (ino, iname, price, type)
ORDERS: (ono, ino, cid, odate, quantity)
```

Write the SQL comments to perform the following queries:

+ List the item with the highest price.
+ Display the name of customer and the name of the item purchased by them.
+ Find out the items that have been ordered by “Rajiv Roy”.
+ Find the name of the customer who has been ordered the item “soap”.
+ Display the name of the customer who has purchased the item with the highest price.
+ List the five rows from the “orders” table.
+ List the name of the customers and the name of the item with their quantity purchased by them on `2010-03-15`.
+ Find out how many customers are there in each city.
+ List the orders placed in months January to March.
+ List the type and total quantity sold for each product.

#colbreak()

#assignment(4)

Write the SQL commands to following relations.
Consider the following relations through SQL commands and specify the required integrity constraints. Insert (at least five) suitable tuples such that the given queries produce some results.

```
BOAT: (boat_id, boat_name, color_of_boat)
SAILOR: (sailor_id, sailor_name, age_of_sailor)
RESERVE: (boat_id, sailor_id, date_of_reserve, day)
```

+ Find the `sailor_id` whose name starts with `'A'` and ends with `'e'`.
+ Find the name of sailors who reserved boat "Titanic" on `2011-03-20`.
+ Find the number of red colored boats.
+ Find the number of boats reserved by each sailor.
+ Find the color of boats reserved by "Hirak".
+ Find the `sailor_id`s and `sailor_name`s who have reserved boats on Tuesday.
+ List the `boat_id`s and `boat_name`s for 'Red' and 'Green' colored boats only.
+ Find the `sailor_id`s and `sailor_name`s who didn't have any reserved boat.
+ Select the names of the sailors who have reserved at least two boats.
+ Find the names of the sailors with age over 20 who have not reserved any red boat.
+ Find the IDs and names of the sailors who have reserved two different boats on the same day.
+ Find the name of the sailor who have reserved at least one boat.

#assignment(5)

Write the SQL commands to following relations.
Consider the following relational schema:
```
CUSTOMER: (cust_id, cust_name, annual_revenue)
SHIPMENT: (shipment_id, cust_id, weight, truck_id, destination)
TRUCK: (truck_id, driver_name)
CITY: (city_name, population)
```
Create table and insert sufficient records to the tables by a proper form design.

+ Delete all cities from the database with population fewer than 5000 and update the `SHIPMENT` table accordingly.
+ List cities in database having largest and smallest populations.
+ List the names and population of cities that have received shipments weights over 100 pounds.
+ List all customers having over Rs. 5 million in annual revenue who have sent shipments weighting less than 1 pound.
+ List all minimum weights of packets sent by the cities with population over 1 million.
+ List the name and annual revenue of customer whose `SHIPMENT` has been delivered by truck driver 'Jonshon'.
+ List the name of the drivers who have delivered shipments to every city.
+ Create views for the customers with annual revenue over Rs. 500000.
+ List the names of drivers who have delivered shipments weighing over 100 pounds.
+ List the cities that have received shipments from every customer.
+ List the maximum weight of the packege sent to each of the cities.
+ Find the average weight of a shipment sent to highest populated city.
+ Convert the weight of every shipment from pounds to kilograms by dividing the weight by `2.2`.

#assignment(6)

Write the SQL commands to following relations.
Consider the following relational schema:

```
HOTEL: (h_no, h_name, city)
ROOM: (r_no, h_no, type, price)
BOOKING: (h_no, g_no, date_from, date_to, r_no)
GUEST: (g_no, g_name, address)
```

Create table and insert sufficient records to the tables and answer the given queries.

+ List all double and family rooms with price below 2000 per night in descending order of their price.
+ List the details of all rooms at the Taj Hotel including the name of the guest staying in the room if the room is occupied.
+ Find out the total revenue from all double rooms.
+ Find out the room which has second maximum room charge among the hotels.
+ Give the names of hotel having no booking from `2011-01-30` to `2011-02-04`.
+ Give the details of the guest who have booked in Hotel Raj in Kolkata in Room No. 223.
+ Give the name of the guest who has booked room in 'Sun Flower' hotel maximum number of times.
+ Give the name of the city in which there is no room above the price of 1900.
+ Find the total income from booking for Taj Hotel today.
+ List the rooms that are currently unoccupied at Taj hotel.
+ List the booking for which no `date_to` has been specified.
+ List the number of rooms in each hotel in Madurai.

#assignment(7)

Write the SQL commands to following relations:

```
EMPLOYEE: (Fname, Lname, ssn, bdate, address, sex, salary, superssn, dno)
DEPARTMENT: (dname, dnumber, mgrssn)
DEPT_LOCATION: (dnumber, dlocation)
PROJECT: (pname, pnumber, plocation, dnum)
WORKS_ON: (essn, pno, hours)
DEPENDENT: (essn, dependent_name, sex, bdate, relationship)
```

Create table and insert sufficient records to the tables and answer the given queries.

+ Retrieve the names of employees in department `d005` who work more than 10 hours/week on the Product X.
+ List the name of employees who are dependent with the same first name as themselves.
+ Find the names of employees that are directly supervised by 'Franklin Wong'.
+ For each project, list the project name and the total hours per week (by all employees) spent on that project.
+ Retrieve the name of employees who work on every project.
+ Retrieve the name of employees who do not work on any project.
+ For each department retrieve department name and average salary of the employees working in that department.
+ Retrieve the average salary of all female employees.
+ Find the names and addresses of employees who work on at least one project located in Houston but whose department has no location in Houston.
+ List the last name of department managers who have no dependents.


