#import "tpl.typ": *
#show: body => apply(body)
#let semibold(body) = text(weight: 600, body)
#text(size: 1.3em, align(center)[#semibold[Lab Assignments] \ _on_ \ #semibold[Object Oriented Programming using Java]])
#set enum(full: true, numbering: (..args) => {
  let patterns = ("1.", "a)")
  let pattern = patterns.at(calc.min(args.pos().len(), patterns.len()) - 1)
  numbering(pattern, args.pos().last())
})

#assignment(1)
#objective[To learn how to write simple Java programs.]

#let sup = super
#show math.equation: set text(font: "GFS Neohellenic Math", size: 1.2em)
#set raw(lang: "java")

Write programs to perform following tasks.

+ Print your name.
+ Read the price of an item in the decimal form (like 75.95) and print the output in paise (like 7595 paise).
+ Calculate the area and the perimeter of a rectangle.
+ Convert the given temperature in Fahrenheit to Celsius using the following conversion formula: _C_ = (_F_ − 32)/1.8.
+ Determine sum of the following series for given value of _n_: 1 + 1/2 + 1/3 + ⋯ + 1/_n_. Print the result up to two decimal places.
+ Take your first and last name as command line arguments and print after concatenating them into a string.
+ Find the product of the sum of digits and the integer with its digits reversed of a given integer (take input using command-line argument).
+ Find the factorial of a given integer number using recursion (take input using command-line argument).
+ Show Fibonacci series up to _n_-th terms using recursion.
+ Calculate the series 1 + _x_ + _x_#sup[2] + _x_#sup[3] + _x_#sup[4] + ⋯ up to _n_-th terms).
+ Calculate the simple interest (S.I.) with inputs of principle (_p_), time in years (_n_) and rate of interest (_r_) [take input using command-line argument].
+ Find the real roots of the quadratic equation _ax_#sup[2] + _bx_ + _c_ = 0 where _a_, _b_ and _c_ are constants.
+ Print all prime number within a given range.
+ Print all Armstrong number within a given range.
+ Calculate GCD and LCM of two numbers. (Implement 2 versions).
+ Find sum and average of several integers (in an array) using enhanced-for loop.
+ Implement linear search. Take the values via command line argument.
+ Implement binary search.
+ Implement Bubble sort, Selection sort, Insertion sort in a single menu driven program.
+ Count number of words in a string.
+ Check whether a string is palindrome or not. Make this Case Insensitive.
+ Perform addition, subtraction and multiplication of two matrices using a menu driven program.

#colbreak()

#assignment(2)
#objective[To learn about the concept of classes and objects.]

Write programs to perform the following tasks.

+ Add two numbers by taking input using command-line input, `Scanner` class and `BufferedReader` class. Implement two versions.
+ Find surface area and volume of a cylinder using constructors - keyboard input or command-line input.
+ Find surface area and volume of cone using constructors - keyboard input or command-line input.
+ Add two complex numbers using concept of methods returning objects and methods taking objects as parameters.
+ Find a number from an array of numbers.
+ Show that `static` blocks execute before any object creation and implement the use of static variable.
+ Create a class; put a method inside this class which will return a class reference; return the same class and/or different class object.
+ Solve the problems below:
  + Make a `Student` class with proper attributes like roll number, name, stream, and college. From `main()` create such two students and show their information. 
  + Consider the `Student` class in the previous program. Assume that a student studies 6 subjects. Each subject has a title, internal marks and theory marks. Write a Program to define the `Student` class, including the subjects as an array. From `main()`, create two such students and show their information including the names of the subjects and grand total marks.
  + Consider the `Student` class in the first program 8.a. Assume that students study varying number of subjects. Each subject has a title, internal marks and theory marks. Write a Program to define Student class including the subjects as vararg argument of constructor. From main create such two students and show their information including subjects’ name and grand total marks.
+ Design a class to represent a bank account. Include the following:
  #pad(left: 1em)[
  / Fields :
    - Name of the depositor
    - Address of the depositor
    - Account number
    - Balance amount in the account
  / Methods :
    - To assign initial values
    - To deposit an amount
    - To withdraw an amount after checking balance
    - To display the name, address and balance of a customer.
  ]
  From `main()` create object and call these methods.

#colbreak()

#assignment(3)
#objective[To learn about inheritance, polymorphism, and abstract classes.]

+ Create a class shape with three methods to calculate area of triangle, rectangle and square with method overloading.
+ Create an abstract class `Shape` with two abstract methods, `area()` and `disp()`. Now design three concrete classes `Rectangle`, `Circle` and `Triangle` can compute area and display its separately.
+ Overload the constructors for classes `Area` and `Volume` of a rectangular figure and also display its area and volume. `Area` is the superclass and `Volume` is the subclass.
+ Create a class `Employee`, having instance variables `name` and `id`. Create its subclass named `Scientist` which has instance variables `no_of_publication` and `experience`. Now create its subclass, say `DScientist` which has instance variable `award`. Put a method like: `public String toString() { }` in every class where you describe about the class and from `main()` method create object of each class and print each object.
+ Create a class with a method `void show()` and make three subclasses of it and all subclasses have this `show()` method overridden and call those methods using their corresponding object references.
+ Do the problem 4 using dynamic method dispatching.
+ Assume that a bank maintains two kinds of account for its customers, one called savings account and other called current account. The savings account provides compound interest and withdrawal facilities but no cheque book facility. The current account provides cheque book facility but no interest. Current account holders should also maintain a minimum balance (say Rs. 1000) and if the balance falls below this level a service charge is imposed (say Rs. 100). Create a class `Account` that stores customer name, account number and type of account. From this class derive two classes `Curr_Acct` and `Savn_Acct` respectively to make them more specific to their requirements. Include the necessary methods to achieve the following tasks:
  + Accept deposit from a customer and update the balance.
  + Display the balance.
  + Compute and deposit interest.
  + Permit withdrawal and update the balance.
  + Check for minimum balance, impose penalty, if necessary, and update balance.
  Use constructors to initialise the class members.
+ Create a class `Parent` having instance variables `id`, `name` and `address`. Create a class `ChildOne` having instance variables `id`, `name`, `address` and `marks`. Also create another class `ChildTwo` with instance variables `id`, `name`, `address`, `qualification` and `salary`. Within each class define your own method to display values of these variables. Design the program using `super` call with proper parameter and use object of each class from `main()` to display their properties.

#colbreak()

#assignment(4)
#objective[To learn the concept of interfaces, inner classes and packages.]

+ Create an interface named `Shape`. Create two subclasses of it named `Circle` and `Sphere`. Create objects of the two classes and calculate their area/surface area.
+ Create an interface named `CircularBase` (that contains base details). Create another class `_3dShape` (Contains height, volume). Inherit two classes `Cone` and `Cylinder` from the interface and the class.
+ Create a class which contains an inner class. Show that inner class can use member of outer class directly, but Outer class can use member of inner class only through its object. Check the name of class file, you created.
+ Create two interfaces, each with two methods. Inherit a new interface from the two, adding a new method. Create a class by implementing the new interface and also inheriting from a concrete class. In `main()` method, create an object of derived class and call the methods [do all without package statement].
5. Create a class with variable(s) and method(s) (all will be default accessed) under package `pOne`. Now create a class under package `pTwo`, which is subclass of firstly created class. In the method here (_i.e._ class of `pTwo`) call variable(s) and method(s) of previous class (_i.e._ class of `pOne`). If errors come, rectify them. Now from `main()` (under working directory) access members of the second class.
+ Create an interface containing three methods, in a package `pkgOne`. Implement the interface from a class under package `pkgTwo`. From `main()`, under working directory, create object of the class and call methods of interface.

#v(2em)
#assignment(5)
#objective[To learn about `String`, `Collection` and `File`.]

1. Take a sting from keyboard and convert into character array (new one).
2. Take a string from keyboard and a `char` array (filled up to length 5). Now append the string to that `char` array. Show the `char` array.
3. Write a java code to differentiate `equals()` method and `==` operator.
4. Find length of a string taken from keyboard and also find the length of that string except the spaces at the beginning and the end of the string.
5. Sort ten names in ascending order.
6. Check if `"Tech"` is present in `"University of Technology"` or not. If yes return its position.
7. Take a sentence and convert it into string arrays and sort the words using any sorting technique.
8. Show that the `String` objects are immutable but `StringBuffer` objects are mutable.
9. Convert a `StringBuffer` object into a `String` object. Print the final result.
10. Check whether a given string is a palindrome or not. Ignore the cases.
11. Convert a string into an array of strings and display them [use command-line argument].
12. Take a shopping list of five items from the command line and store them in a vector.
13. Write a program to concatenate the contents of two strings.

