class SolveQuadraticEquation {
    public static void main(String args[]) {
	if (args.length != 3) {
	    System.err.println("Usage: SolveQuadraticEquation A B C");
	    System.err.println("Solves for the real roots of the quadratic equation: Ax² + Bx + C = 0");
	    System.exit(1);
	}
	try {
	    double a = Double.parseDouble(args[0]);
	    double b = Double.parseDouble(args[1]);
	    double c = Double.parseDouble(args[2]);
	    double d = b * b - 4 * a * c;
	    if (d < 0.0) {
		System.out.println("The equation has no real roots.");
		return;
	    }
	    double dd = Math.sqrt(d);
	    double x1 = (-b + dd) / 2 * a, x2 = (-b - dd) / 2 * a;
	    System.out.println("The equation has two " + (dd == 0.0 ? "equal" : "distinct") + " real roots: " + x1 + ", " + x2);
	} catch (NumberFormatException e) {
	    System.err.println("Invalid number given as input.");
	    System.exit(1);
	}
    }
}

