import java.util.*;

class Subject {
    String title;
    int internal, theory;
    Subject(String title, int internal, int theory) {
        this.title = title;
        this.internal = internal;
        this.theory = theory;
    }
    static Subject input(Scanner sc) {
    	System.out.println("Enter details of subject:");
    	System.out.print("Enter title: ");
    	String title = sc.nextLine();
    	System.out.print("Enter internal marks: ");
    	int internal = sc.nextInt();
    	System.out.print("Enter theory marks: ");
    	int theory = sc.nextInt();
    	sc.skip("\n");
    	return new Subject(title, internal, theory);
    }
    void display() {
    	System.out.println("  Subject " + title + " marks obtained:");
	    System.out.println("    Internal: " + internal);
	    System.out.println("    Theory: " + theory);
	    System.out.println("    Total: "  + (internal + theory));
    }
}

class Student {
    long roll;
    String name;
    String stream;
    String college;
    Subject[] subjects;
    Student(long roll, String name, String stream, String college,
            Subject... subjects) {
        this.roll = roll;
        this.name = name;
        this.stream = stream;
        this.college = college;
        this.subjects = subjects;
    }
    static Student input(Scanner sc) {
    	System.out.println("Enter the details of the student:");
    	System.out.print("Enter Roll no.: ");
    	long roll = sc.nextLong();
    	sc.skip("\n");
    	System.out.print("Enter name: ");
    	String name = sc.nextLine();
    	System.out.print("Enter stream: ");
    	String stream = sc.nextLine();
    	System.out.print("Enter college: ");
    	String college = sc.nextLine();
    	System.out.print("Enter the number of subjects: ");
    	Subject[] subjects = new Subject[sc.nextInt()];
    	sc.skip("\n");
    	for (int i = 0; i < subjects.length; i++) {
    	    System.out.print("For subject " + (i + 1) + ": ");
    	    subjects[i] = Subject.input(sc);
    	}
    	return new Student(roll, name, stream, college, subjects);
    }
    void display() {
    	System.out.println("Student details:");
	    System.out.println("  Roll No.: " + roll);
	    System.out.println("  Name: " + name);
	    System.out.println("  Stream: "  + stream);
	    System.out.println("  College: " + college);
	    for (int i = 0; i < subjects.length; i++) {
	        subjects[i].display();
	    }
    }
}

class StudentsWithSubjects {
    public static void main(String args[]) {
	    var sc = new Scanner(System.in);
    	System.out.print("Enter the number of students: ");
    	Student[] students = new Student[sc.nextInt()];
    	sc.skip("\n");
    	System.out.println("Input details of the student:");
    	for (int i = 0; i < students.length; i++) {
    	    System.out.print("For student " + (i + 1) + ": ");
    	    students[i] = Student.input(sc);
    	}
    	System.out.println("Display details of the student:");
    	for (int i = 0; i < students.length; i++) {
    	    System.out.print("For student " + (i + 1) + ": ");
    	    students[i].display();
    	}
    }
}

/*
$ java StudentsWithSubjects 
Enter the number of students: 2
Input details of the student:
For student 1: Enter the details of the student:
Enter Roll no.: 123
Enter name: ABC DEF
Enter stream: B.Sc.
Enter college: BCCR
Enter the number of subjects: 3
For subject 1: Enter details of subject:
Enter title: Physics
Enter internal marks: 12
Enter theory marks: 43 
For subject 2: Enter details of subject:
Enter title: Mathematics
Enter internal marks: 14
Enter theory marks: 45
For subject 3: Enter details of subject:
Enter title: Statistics
Enter internal marks: 11
Enter theory marks: 39
For student 2: Enter the details of the student:
Enter Roll no.: 456
Enter name: PQR XYZ
Enter stream: B.A.
Enter college: BCCR
Enter the number of subjects: 4
For subject 1: Enter details of subject:
Enter title: History
Enter internal marks: 14
Enter theory marks: 49
For subject 2: Enter details of subject:
Enter title: Philosophy
Enter internal marks: 15
Enter theory marks: 44
For subject 3: Enter details of subject:
Enter title: Political Science
Enter internal marks: 17
Enter theory marks: 48
For subject 4: Enter details of subject:
Enter title: Literature
Enter internal marks: 12
Enter theory marks: 41
Display details of the student:
For student 1: Student details:
  Roll No.: 123
  Name: ABC DEF
  Stream: B.Sc.
  College: BCCR
  Subject Physics marks obtained:
    Internal: 12
    Theory: 43
    Total: 55
  Subject Mathematics marks obtained:
    Internal: 14
    Theory: 45
    Total: 59
  Subject Statistics marks obtained:
    Internal: 11
    Theory: 39
    Total: 50
For student 2: Student details:
  Roll No.: 456
  Name: PQR XYZ
  Stream: B.A.
  College: BCCR
  Subject History marks obtained:
    Internal: 14
    Theory: 49
    Total: 63
  Subject Philosophy marks obtained:
    Internal: 15
    Theory: 44
    Total: 59
  Subject Political Science marks obtained:
    Internal: 17
    Theory: 48
    Total: 65
  Subject Literature marks obtained:
    Internal: 12
    Theory: 41
    Total: 53
*/

