class DigitCalculations {
    static int sumOfDigits(int n) {
        int sum = 0;
        for (; n > 0; n /= 10) {
            sum += n % 10;
        }
        return sum;
    }
    static int reversedDigits(int n) {
        int r = 0;
        for (; n > 0; n /= 10) {
            r *= 10;
            r += n % 10;
        }
        return r;
    }
    public static void main(String args[]) {
        if (args.length != 1) {
            System.err.println("Usage: DigitCalculations <integer>");
            System.exit(1);
        }
        try {
            int n = Integer.parseInt(args[0]);
            int p = sumOfDigits(n) * reversedDigits(n);
            System.out.println("Result: " + p);
        } catch (NumberFormatException e) {
            System.err.println("Invalid integer argument");
            System.exit(1);
        }
    }
}

