class Factorial {
    static double factorial(int n) {
        if (n < 0) {
            throw new IllegalArgumentException("Negative factorial is unsupported.");
        }
        if (n == 0) {
            return 1.0;
        } else {
            return n * factorial(n - 1);
        }
    }
    public static void main(String args[]) {
        if (args.length != 1) {
            System.err.println("Usage: Factorial <integer>");
            System.exit(1);
        }
        try {
            int n = Integer.parseInt(args[0]);
            System.out.println(n + "! = " + factorial(n));
        } catch (NumberFormatException e) {
            System.err.println("Invalid integer argument");
            System.exit(1);
        }
    }
}

