class Fibonacci {
    static void showFibonacci(int n) {
        showFibonacci(n, 0, 1);
    }
    static void showFibonacci(int n, long a, long b) {
        if (n <= 0) {
            return;
        }
        System.out.print(" " + a);
        showFibonacci(n - 1, b, a + b);
    }
    public static void main(String args[]) {
        if (args.length != 1) {
            System.err.println("Usage: Fibonacci <number of terms>");
            System.exit(1);
        }
        try {
            int n = Integer.parseInt(args[0]);
            System.out.print("Fibonacci sequence:");
            showFibonacci(n);
            System.out.println();
        } catch (NumberFormatException e) {
            System.err.println("Invalid integer argument");
            System.exit(1);
        }
    }
}

