class SimpleInterest {
    public static void main(String args[]) {
	if (args.length != 3) {
	    System.err.println("Usage: SimpleInterest PRINCIPLE TIME-IN-YEARS YEARLY-INTEREST-RATE");
	    System.err.println("Interest rate per annum needs to be given as a percentage.");
	    System.exit(1);
	}
	try {
	    double principle = Double.parseDouble(args[0]);
	    double timeInYears = Double.parseDouble(args[1]);
	    double yearlyInterestRate = Double.parseDouble(args[2]);
	    double interest = principle * timeInYears * yearlyInterestRate / 100.0;
	    System.out.println("Interest amount: " + interest);
	} catch (NumberFormatException e) {
	    System.err.println("Invalid number given as input.");
	    System.exit(1);
	}
    }
}


