class InsufficientBalanceException extends Exception {}

class BankAccount {
    String name, address;
    long accountNo;
    double balance;
    BankAccount(String name, String address, long accountNo, double balance) {
        this.name = name;
        this.address = address;
        this.accountNo = accountNo;
        this.balance = balance;
    }
    void deposit(double amount) throws IllegalArgumentException {
        if (amount < 0.0)
            throw new IllegalArgumentException("Can not deposit negative amount of money. Use withdraw() instead.");
        balance += amount;
    }
    void withdraw(double amount) {
        if (amount < 0.0)
            throw new IllegalArgumentException("Can not withdraw negative amount of money. Use deposit() instead.");
        else if (amount > balance)
            throw new InsufficientBalanceException("Available balance: " + balance + " but tried to withdraw: " + amount + " with the shortfall of " + (amount - balance));
    }
    void display() {
        System.out.println(
            "Customer details: \n" +
            "  Name: " + name + "\n" +
            "  Address: " + address + "\n" +
            "  Account Number: " + accountNo + "\n" +
            "  Balance: " + String.format("%.2f", balance));
    }
}

class BankAccountExample {
    public static void main(String args[]) {
        
    }
}
