import java.util.Scanner;
import java.util.InputMismatchException;
import java.util.stream.LongStream;

class ArmstrongRange {
    static boolean isArmstrong(long n) {
	if (n < 0) {
	    return isArmstrong(-n);
	}
	long len = 1 + (long) Math.log10(n), sum = 0L, m = n;
	for (long i = 0; i < len; m /= 10, i++) {
	    sum += (long) Math.pow(m % 10, len);
	}
	return sum == n;
    }
    public static void main(String args[]) {
        try {
            Scanner i = new Scanner(System.in);
            System.out.print("Enter the range: ");
            var lower = i.nextLong();
	    var upper = i.nextLong();
            System.out.print("Armstrong numbers in the range of " + lower + " to " + upper + " are:");
	    LongStream.range(lower, upper)
		.filter(ArmstrongRange::isArmstrong)
		.forEach(n -> System.out.print(" " + n));
	    System.out.println();
        } catch (InputMismatchException e) {
            System.err.println("Invalid input for range.");
        }
    }
}

