class NumberTheory {
    static int gcdRecursive(int a, int b) {
        if (b == 0) return a;
        return gcdRecursive(b, a % b);
    }
    static int gcdIterative(int a, int b) {
        while (b != 0) {
            int tmp = b;
            b = a % b;
            a = tmp;
        }
        return a;
    }
    static int lcmByGCD(int a, int b) {
        return a * b / gcdRecursive(a, b);
    }
    static int lcmIterative(int a, int b) {
        int as = a, bs = b;
        while (as != bs) {
            if (as < bs) as += a;
            else if (as > bs) bs += b;
        }
        return as;
    }
}

class GCD_LCM_Recursive {
    public static void main(String args[]) {
        if (args.length != 2) {
            System.out.println("Usage: GCD_LCM_Recursive <a> <b>");
            return;
        }
        try {
            int a = Integer.parseInt(args[0]),
                b = Integer.parseInt(args[1]);
            int gcd = NumberTheory.gcdRecursive(a, b),
                lcm = NumberTheory.lcmByGCD(a, b);
            System.out.println("The GCD and LCM of " + a + " and " + b + " are " + gcd + " and " + lcm + ", respectively.");
        } catch (NumberFormatException e) {
            System.out.println("Invalid integer given as input");
        }
    }
}

class GCD_LCM_Iterative {
    public static void main(String args[]) {
        if (args.length != 2) {
            System.out.println("Usage: GCD_LCM_Iterative <a> <b>");
            return;
        }
        try {
            int a = Integer.parseInt(args[0]),
                b = Integer.parseInt(args[1]);
            int gcd = NumberTheory.gcdIterative(a, b),
                lcm = NumberTheory.lcmIterative(a, b);
            System.out.println("The GCD and LCM of " + a + " and " + b + " are " + gcd + " and " + lcm + ", respectively.");
        } catch (NumberFormatException e) {
            System.out.println("Invalid integer given as input");
        }
    }
}

