import java.util.*;

interface Searcher<E> {
    Searcher<E> takeList(List<E> list);
    int search(E element);
}

class LinearSearcher<E> implements Searcher<E> {
    List<E> list;
    public Searcher<E> takeList(List<E> list) {
        this.list = list;
        return this;
    }
    public int search(E element) {
        int size = list.size();
        for (int i = 0; i < size; i++) {
            if (list.get(i).equals(element)) {
                return i;
            }
        }
        return -1;
    }
}

class PerformLinearSearch {
    public static void main(String args[]) {
        if (args.length == 0) {
            System.err.println("Usage: PerformLinearSearch ITEM ARRAY...");
            return;
        }
        String elementToFind = args[0];
        String[] list = Arrays.copyOfRange(args, 1, args.length);
        System.out.print("The given array:");
        for (int i = 0, len = list.length; i < len; i++) {
            System.out.print(" " + list[i]);
        }
        System.out.println();
        int pos = new LinearSearcher<String>().takeList(Arrays.asList(list)).search(elementToFind);
        if (pos == -1) {
            System.out.println("Element " + elementToFind + " could not be found in the given array.");
        } else {
            System.out.println("Element " + elementToFind + " was found in the given array at position " + (pos + 1) + ".");
        }
    }
}

